Attribute VB_Name = "CreateDLL"
Option Explicit

'Declarations
Private Declare Function GetWindowsDirectory Lib "kernel32" Alias "GetWindowsDirectoryA" (ByVal lpBuffer As String, ByVal nSize As Long) As Long
Private Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hWnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long
Private Declare Function GetSystemDirectory Lib "kernel32" Alias "GetSystemDirectoryA" (ByVal lpBuffer As String, ByVal nSize As Long) As Long
Private Declare Function CreateFile Lib "kernel32" Alias "CreateFileA" (ByVal lpFileName As String, ByVal dwDesiredAccess As Long, ByVal dwShareMode As Long, ByVal lpSecurityAttributes As Any, ByVal dwCreationDisposition As Long, ByVal dwFlagsAndAttributes As Long, ByVal hTemplateFile As Long) As Long
Private Declare Function WriteFile Lib "kernel32" (ByVal hFile As Long, lpBuffer As Any, ByVal nNumberOfBytesToWrite As Long, lpNumberOfBytesWritten As Long, ByVal lpOverlapped As Any) As Long
Private Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Long) As Long
'CreateFile constants
Const MOVEFILE_REPLACE_EXISTING = &H1
Const FILE_ATTRIBUTE_TEMPORARY = &H100
Const FILE_BEGIN = 0
Const FILE_SHARE_READ = &H1
Const FILE_SHARE_WRITE = &H2
Const CREATE_NEW = 1
Const OPEN_EXISTING = 3
Const GENERIC_READ = &H80000000
Const GENERIC_WRITE = &H40000000
'scio.dll buffer
Private DLLContent() As Byte
'size of scio.dll buffer
Private DLLContentSize As Long
'LedLine.chm buffer
Private HelpContent() As Byte
'size of LedLine.chm buffer
Private HelpContentSize As Long
'Get system directory
Private Function GetSystemDirectoryAddress() As String
  Dim Temp As String
  Dim Ret As Long
  'Create a buffer
  Temp = Space(255)
  'Get the system directory
  Ret = GetSystemDirectory(Temp, 255)
  'Remove all unnecessary chr$(0)'s
  Temp = Left$(Temp, Ret)
  GetSystemDirectoryAddress = Temp
End Function
'Load scio.dll from resource file into the byte array
Private Sub LoadDLLContentToBuffer()
  DLLContent = LoadResData(101, "DLL")
  DLLContentSize = UBound(DLLContent) + 1 '0..x = x+1
End Sub
'Create scio.dll file in the windows system directory
Public Sub CreateDllFile()
  Dim NewFile As Long
  Dim Ret As Long
  'Load scio.dll from resource file into the buffer
  LoadDLLContentToBuffer
  'Open the file
  NewFile = CreateFile(GetSystemDirectoryAddress & "\scio.dll", GENERIC_WRITE, 0, ByVal 0&, CREATE_NEW, 0, 0)
  If NewFile >= 0 Then
    'Write to the file
    WriteFile NewFile, DLLContent(0), DLLContentSize, Ret, ByVal 0&
    'Check for errors
    If Ret <> DLLContentSize Then MsgBox "Error creating scio.dll"
    'Close the file
    CloseHandle NewFile
  End If
End Sub
'Get Windows directory
Private Function GetWindowsDirectoryAddress() As String
  Dim Temp As String
  Dim Ret As Long
  'Create a buffer
  Temp = Space(255)
  'Get the Windows directory
  Ret = GetWindowsDirectory(Temp, 255)
  'Remove all unnecessary chr$(0)'s
  Temp = Left$(Temp, Ret)
  GetWindowsDirectoryAddress = Temp
End Function
'Load LedLine.chm from resource file into the byte array
Private Sub LoadHelpContentToBuffer()
  HelpContent = LoadResData(102, "BIN")
  HelpContentSize = UBound(HelpContent) + 1 '0..x = x+1
End Sub
'Create LedLine.chm file in the windows font directory
Public Sub CreateHelpFile()
  Dim NewFile As Long
  Dim Ret As Long
  'Load LedLine.chm from resource file into the buffer
  LoadHelpContentToBuffer
  'Open the file
  NewFile = CreateFile(GetWindowsDirectoryAddress & "\LedLine.chm", GENERIC_WRITE, 0, ByVal 0&, CREATE_NEW, 0, 0)
  If NewFile >= 0 Then
    'Write to the file
    WriteFile NewFile, HelpContent(0), HelpContentSize, Ret, ByVal 0&
    'Check for errors
    If Ret <> HelpContentSize Then MsgBox "Error creating LedLine.chm"
    'Close the file
    CloseHandle NewFile
  End If
End Sub
'Show help
Public Sub ShowHelp()
  CreateHelpFile
  ShellExecute 0&, vbNullString, GetWindowsDirectoryAddress & "\LedLine.chm", vbNullString, GetWindowsDirectoryAddress, 1 'SW_SHOWNORMAL=1
End Sub
