Attribute VB_Name = "LEDLine"
Option Explicit

'Possible LPT port addresses
Public Enum PossiblePortNumbers
  LPT1 = &H378
  LPT2 = &H278
End Enum
'Current port (LPT1 or LPT2)
Private CurrentPort As PossiblePortNumbers
'How many counts per millisecond
Private NumOfCountsPerMillisecond As Long
'LED Table Array
Private LEDTableArray(200) As Long
'How many colomns are
Private LEDTableLength As Long
'LEDs on delay
Private SwitchOnDelay As Long
'LEDs off delay
Private SwitchOffDelay As Long
'Determines where the line begins
Private LineOffset As Long
'API Declarations
Private Declare Function Inp Lib "scio.dll" Alias "Inp32" (ByVal PortAddress As Integer) As Integer
Private Declare Sub Out Lib "scio.dll" Alias "Out32" (ByVal PortAddress As Integer, ByVal Value As Integer)
'Get current port 278h or 378h
Public Function GetPortNumber() As PossiblePortNumbers
  GetPortNumber = CurrentPort
End Function
'Set current port 278h or 378h
Public Sub SetPortNumber(Val As PossiblePortNumbers)
  CurrentPort = Val
End Sub
'Get Switch On Delay
Public Function GetSwitchOnDelay() As Long
  GetSwitchOnDelay = SwitchOnDelay
End Function
'Set Switch On Delay
Public Sub SetSwitchOnDelay(Val As Long)
  SwitchOnDelay = Val
End Sub
'Get Switch Off Delay
Public Function GetSwitchOffDelay() As Long
  GetSwitchOffDelay = SwitchOffDelay
End Function
'Set Switch Off Delay
Public Sub SetSwitchOffDelay(Val As Long)
  SwitchOffDelay = Val
End Sub
'Get Line OffSet
Public Function GetLineOffset() As Long
  GetLineOffset = LineOffset
End Function
'Set Line OffSet
Public Sub SetLineOffset(Val As Long)
  LineOffset = Val
End Sub
'Write Data to LED Line
Public Sub LED_Line(Val As Byte)
  Out CurrentPort, Val
End Sub
'Write Control to LED Line
Public Sub LED_Line_Control(Val As Byte)
  Out CurrentPort + 2, Val
End Sub
'Read Status from LED Line
Public Function LED_Line_Status() As Byte
  LED_Line_Status = Inp(CurrentPort + 1)
End Function
'Read Status Desired Bit from LED Line
'Return 1 if there is a contact,oterwise return 0
Public Function LED_Line_Status_Desired_Bit() As Byte
  LED_Line_Status_Desired_Bit = 1 - (LED_Line_Status \ 16 Mod 2)
End Function
'Show LED table once
Public Sub LEDTableShow()
  Static Locked As Boolean
  Dim CurrentLinePointer As Long
  Dim i, j As Long
  If Not Locked Then
    Locked = True
    For i = 0 To LEDTableLength - 1
      For j = 0 To SwitchOffDelay * NumOfCountsPerMillisecond: Next j
      LED_Line (LEDTableArray(CurrentLinePointer))
      For j = 0 To SwitchOnDelay * NumOfCountsPerMillisecond: Next j
      LED_Line (0)
      CurrentLinePointer = CurrentLinePointer + 1
    Next i
    Locked = False
  End If
End Sub
'Clear LED Table Array
Private Sub ClearLEDTableArray()
  Dim i As Long
  For i = 0 To UBound(LEDTableArray)
    LEDTableArray(i) = 0
  Next i
End Sub
'Write String To LED Table
Public Sub LEDTableWriteString(Str As String)
  Dim i, j As Long
  Str = Space(LineOffset) + Str
  LEDTableLength = Len(Str) * 6
  ClearLEDTableArray
  For i = 0 To Len(Str) - 1
    For j = 0 To 4
      Select Case Asc(Mid(Str, i + 1, 1))
        Case 32 To 126
          LEDTableArray(i * 6 + j) = FontContent((Asc(Mid(Str, i + 1, 1)) - 32) * 5 + j)
        Case Else
          LEDTableArray(i * 6 + j) = FontContent(j) 'Spacebar if unknown symbol
      End Select
    Next j
  Next i
End Sub
'Init LED Line
Public Sub LEDLineInit()
  CreateDllFile
  LoadFontContentToBuffer
  NumOfCountsPerMillisecond = GetDelayTime
  LED_Line_Control (11) 'Switch off Control LEDs
End Sub
